Index: src/edu/ucsb/nceas/metacat/EmlSAXHandler.java
===================================================================
--- src/edu/ucsb/nceas/metacat/EmlSAXHandler.java	(revision 2076)
+++ src/edu/ucsb/nceas/metacat/EmlSAXHandler.java	(revision 2077)
@@ -1488,838 +1427,748 @@
                         "Problem with starting thread for writing XML Index. "
                                 + e.getMessage());
             }
-     }
-   }
-   
-  /* The method to write all access rule into db */
-  private void writeAccessRuleToDB() throws SAXException
-  {
-    //Delete old permssion
-    deletePermissionsInAccessTable(docid);
-    //write top leve access rule
-    writeTopLevelAccessRuleToDB();
-    //write additional access rule
-    //writeAddtionalAccessRuleToDB();
-  }//writeAccessRuleToDB
-   
-  /* The method to write top level access rule into db. */
-  private void writeTopLevelAccessRuleToDB() throws SAXException
-  {
-    
-    // for top document level
-    Object accessSection = topLevelAccessControlMap.get(docid);
-    boolean top = true;
-    String subSectionId = null;
-    if ( accessSection != null )
-    {
-       AccessSection accessSectionObj = (AccessSection)accessSection;
-           
-       // if accessSection is not null and is not reference
-       if ( accessSectionObj.getReferences() == null)
-       {
-          // write the top level access module into xml_accesssubtree to store info
-          // and then when update to check if the user can update it or not
-          deleteAccessSubTreeRecord(docid);
-          writeAccessSubTreeIntoDB(accessSectionObj,TOPLEVEL);
-         
-          //write access section into xml_access table
-          writeGivenAccessRuleIntoDB(accessSectionObj, top, subSectionId);
-          // write relative online data file into xml_access too.
-          /*for (int i= 0; i<onlineDataFileIdVector.size(); i++)
-          {
-            String id = (String)onlineDataFileIdVector.elementAt(i);
-            writeAccessRuleForRalatedDataFileIntoDB(accessSectionObj, id);
-          }*/
-          
-       }
-       else
-       {
-   
-        // this is a reference and go trough the vector which contains all
-        // access object
-        String referenceId = accessSectionObj.getReferences();
-        boolean findAccessObject = false;
-        MetaCatUtil.debugMessage("referered id for top access: "+ 
-                               referenceId, 35);
-        for (int i=0; i<accessObjectList.size(); i++)
-        {
-          AccessSection accessObj = (AccessSection)accessObjectList.elementAt(i);
-          String accessObjId = accessObj.getSubTreeId();
-          if (referenceId != null && accessObj != null &&
-              referenceId.equals(accessObjId))
-          {
-            // make sure the user didn't change any thing in this access moduel
-            // too if user doesn't have all permission
-            if (needCheckingAccessModule)
-            {
-              
-              Stack newStack = accessObj.getStoredTmpNodeStack();
-              //revise order
-              newStack = MetaCatUtil.reviseStack(newStack);
-               // go throught the vector of unChangableAccessSubtreevector
-              // and find the one whose id is as same as referenceid
-              AccessSection oldAccessObj = 
-                       getAccessSectionFromUnchangableAccessVector(referenceId);
-              //if oldAccessObj is null something is wrong
-              if (oldAccessObj == null)
-              {
-                throw new SAXException(UPDATEACCESSERROR);
-              }//if
-              else
-              {
-                // Get the node stack from old access obj
-                Stack oldStack = oldAccessObj.getSubTreeNodeStack();
-                comparingNodeStacks(newStack, oldStack);
-              }//else
-            }//if
-            // write accessobject into db
-            writeGivenAccessRuleIntoDB(accessObj, top, subSectionId);
-            // add access rule for related on line data id too.
-            /*for (int j= 0; j<onlineDataFileIdVector.size(); j++)
-            {
-              String id = (String)onlineDataFileIdVector.elementAt(j);
-              writeAccessRuleForRalatedDataFileIntoDB(accessObj, id);
-            }*/
-            
-            
-            //write the reference access into xml_accesssubtree too
-             // write the top level access module into xml_accesssubtree to store info
-             // and then when update to check if the user can update it or not
-            deleteAccessSubTreeRecord(docid);
-            writeAccessSubTreeIntoDB(accessSectionObj,TOPLEVEL);
-            writeAccessSubTreeIntoDB(accessObj, SUBTREELEVEL);
-            findAccessObject = true;
-            break;
-          }
-        }//for
-        // if we couldn't find an access subtree id for this reference id
-        if (!findAccessObject)
-        {
-          throw new SAXException("The referenceid: " + referenceId +
-                               " is not access subtree");
-        }//if
-      }//else
-      
-     
-    }//if
-    else
-    {
-      // couldn't find a access section object 
-      MetaCatUtil.debugMessage("couldn't find access control for document: "+
-                                docid, 35);
+        }
     }
-    
-  }//writeTopLevelAccessRuletoDB
-  
-  /* Given a subtree id and find the responding access section*/
-  private AccessSection getAccessSectionFromUnchangableAccessVector(String id)
-  {
-    AccessSection result = null;
-    // Makse sure the id
-    if (id == null || id.equals(""))
+
+    /* The method to write all access rule into db */
+    private void writeAccessRuleToDB() throws SAXException
     {
-      return result;
-    }
-    // go throught vector and find the list
-    for (int i=0; i<unChangableAccessSubTreeVector.size();i++)
+        //Delete old permssion
+        deletePermissionsInAccessTable(docid);
+        //write top leve access rule
+        writeTopLevelAccessRuleToDB();
+        //write additional access rule
+        //writeAddtionalAccessRuleToDB();
+    }//writeAccessRuleToDB
+
+    /* The method to write top level access rule into db. */
+    private void writeTopLevelAccessRuleToDB() throws SAXException
     {
-      AccessSection accessObj = (AccessSection)
-                                 unChangableAccessSubTreeVector.elementAt(i);
-      if (accessObj.getSubTreeId() != null && 
-         (accessObj.getSubTreeId()).equals(id))
-      {
-        result = accessObj;
-      }//if
-    }//for
-    return result;
-  }//getAccessSectionFromUnchangableAccessVector
-      
-  /* Compare two node stacks to see if they are same */
-  private void comparingNodeStacks(Stack stack1, Stack stack2) 
-                                 throws SAXException
-  {
-    // make sure stack1 and stack2 are not empty
-    if (stack1.isEmpty() || stack2.isEmpty())
+
+        // for top document level
+        Object accessSection = topLevelAccessControlMap.get(docid);
+        boolean top = true;
+        String subSectionId = null;
+        if (accessSection != null) {
+            AccessSection accessSectionObj = (AccessSection) accessSection;
+
+            // if accessSection is not null and is not reference
+            if (accessSectionObj.getReferences() == null) {
+                // write the top level access module into xml_accesssubtree to
+                // store info
+                // and then when update to check if the user can update it or
+                // not
+                deleteAccessSubTreeRecord(docid);
+                writeAccessSubTreeIntoDB(accessSectionObj, TOPLEVEL);
+
+                //write access section into xml_access table
+                writeGivenAccessRuleIntoDB(accessSectionObj, top, subSectionId);
+                // write relative online data file into xml_access too.
+                /*
+                 * for (int i= 0; i <onlineDataFileIdVector.size(); i++) {
+                 * String id = (String)onlineDataFileIdVector.elementAt(i);
+                 * writeAccessRuleForRalatedDataFileIntoDB(accessSectionObj,
+                 * id);
+                 */
+
+            } else {
+
+                // this is a reference and go trough the vector which contains
+                // all
+                // access object
+                String referenceId = accessSectionObj.getReferences();
+                boolean findAccessObject = false;
+                MetaCatUtil.debugMessage("referered id for top access: "
+                        + referenceId, 35);
+                for (int i = 0; i < accessObjectList.size(); i++) {
+                    AccessSection accessObj = (AccessSection) accessObjectList
+                            .elementAt(i);
+                    String accessObjId = accessObj.getSubTreeId();
+                    if (referenceId != null && accessObj != null
+                            && referenceId.equals(accessObjId)) {
+                        // make sure the user didn't change any thing in this
+                        // access moduel
+                        // too if user doesn't have all permission
+                        if (needCheckingAccessModule) {
+
+                            Stack newStack = accessObj.getStoredTmpNodeStack();
+                            //revise order
+                            newStack = MetaCatUtil.reviseStack(newStack);
+                            // go throught the vector of
+                            // unChangableAccessSubtreevector
+                            // and find the one whose id is as same as
+                            // referenceid
+                            AccessSection oldAccessObj = getAccessSectionFromUnchangableAccessVector(referenceId);
+                            //if oldAccessObj is null something is wrong
+                            if (oldAccessObj == null) {
+                                throw new SAXException(UPDATEACCESSERROR);
+                            }//if
+                            else {
+                                // Get the node stack from old access obj
+                                Stack oldStack = oldAccessObj
+                                        .getSubTreeNodeStack();
+                                comparingNodeStacks(newStack, oldStack);
+                            }//else
+                        }//if
+                        // write accessobject into db
+                        writeGivenAccessRuleIntoDB(accessObj, top, subSectionId);
+                        // add access rule for related on line data id too.
+                        /*
+                         * for (int j= 0; j <onlineDataFileIdVector.size();
+                         * j++) { String id =
+                         * (String)onlineDataFileIdVector.elementAt(j);
+                         * writeAccessRuleForRalatedDataFileIntoDB(accessObj,
+                         * id);
+                         */
+
+                        //write the reference access into xml_accesssubtree
+                        // too
+                        // write the top level access module into
+                        // xml_accesssubtree to store info
+                        // and then when update to check if the user can update
+                        // it or not
+                        deleteAccessSubTreeRecord(docid);
+                        writeAccessSubTreeIntoDB(accessSectionObj, TOPLEVEL);
+                        writeAccessSubTreeIntoDB(accessObj, SUBTREELEVEL);
+                        findAccessObject = true;
+                        break;
+                    }
+                }//for
+                // if we couldn't find an access subtree id for this reference
+                // id
+                if (!findAccessObject) { throw new SAXException(
+                        "The referenceid: " + referenceId
+                                + " is not access subtree"); }//if
+            }//else
+
+        }//if
+        else {
+            // couldn't find a access section object
+            MetaCatUtil.debugMessage(
+                    "couldn't find access control for document: " + docid, 35);
+        }
+
+    }//writeTopLevelAccessRuletoDB
+
+    /* Given a subtree id and find the responding access section */
+    private AccessSection getAccessSectionFromUnchangableAccessVector(String id)
     {
-      MetaCatUtil.debugMessage("Because stack is empty!", 35);
-      throw new SAXException(UPDATEACCESSERROR);
-    }
-    // go throw two stacks and compare every element
-    while (!stack1.isEmpty())
+        AccessSection result = null;
+        // Makse sure the id
+        if (id == null || id.equals("")) { return result; }
+        // go throught vector and find the list
+        for (int i = 0; i < unChangableAccessSubTreeVector.size(); i++) {
+            AccessSection accessObj = (AccessSection) unChangableAccessSubTreeVector
+                    .elementAt(i);
+            if (accessObj.getSubTreeId() != null
+                    && (accessObj.getSubTreeId()).equals(id)) {
+                result = accessObj;
+            }//if
+        }//for
+        return result;
+    }//getAccessSectionFromUnchangableAccessVector
+
+    /* Compare two node stacks to see if they are same */
+    private void comparingNodeStacks(Stack stack1, Stack stack2)
+            throws SAXException
     {
-      // Pop an element from stack1
-      NodeRecord record1 = (NodeRecord) stack1.pop();
-      // Pop an element from stack2(stack 2 maybe empty)
-      NodeRecord record2 = null;
-      try
-      {
-        record2 = (NodeRecord) stack2.pop();
-      }
-      catch (EmptyStackException ee)
-      {
-        MetaCatUtil.debugMessage("Node stack2 is empty but stack1 isn't!", 35);
-        throw new SAXException(UPDATEACCESSERROR);
-      }
-      // if two records are not same throw a exception
-      if (!record1.contentEquals(record2))
-      {
-        MetaCatUtil.debugMessage("Two records from new and old stack are not "+
-                                 "same!", 30);
-        throw new SAXException(UPDATEACCESSERROR);
-      }//if
-    }//while
-    
-    // now stack1 is empty and we should make sure stack2 is empty too
-    if(!stack2.isEmpty())
-    {
-      MetaCatUtil.debugMessage("stack2 still have some elements while stack "+
-                               "is empty! ", 30);
-      throw new SAXException(UPDATEACCESSERROR);
-    }//if
- }//comparingNodeStacks
-  
-   /* The method to write addtional access rule into db. */
-  private void writeAddtionalAccessRuleToDB() throws SAXException
-  {
-    
-     PreparedStatement pstmt = null;
-     boolean topLevel =false;
-    // go through the vector which contains the additional access control 
-    //hashtable. Each hashtable has info for one additonalmetadata container 
-   for (int j= 0; j < additionalAccessMapList.size(); j++)
-   {
-     
-     Hashtable accessControlMap = 
-                                (Hashtable)additionalAccessMapList.elementAt(j);
-     // additional access rule
-     Enumeration en = accessControlMap.keys();
-     
-     while(en.hasMoreElements())
-     {
-       try
-       {
-         // Get subsection id
-          String subSectionId = (String)en.nextElement();
-          MetaCatUtil.debugMessage("sub section id in additional access mapping"
-                                   +"(go through): "+ subSectionId, 35);
-          
-          if (subSectionId == null)
-          {
-            // if id is null, terminate the program
-            throw new SAXException("subtree id is null");
-          }
-          // Get AccessSection Object
-          Object accessSectionObj = accessControlMap.get(subSectionId);
-          if (accessSectionObj == null)
-          {
-            // if accesssection is null, terminate the program
-            throw new SAXException("access subtree is null");
-          }
-          else
-          {
-            AccessSection accessControlObj = (AccessSection)accessSectionObj;
-            // if the access section is not references, write it to db
-            if (accessControlObj.getReferences() == null)
-            {
-              writeGivenAccessRuleIntoDB(accessControlObj, topLevel, 
-                                         subSectionId);
+        // make sure stack1 and stack2 are not empty
+        if (stack1.isEmpty() || stack2.isEmpty()) {
+            MetaCatUtil.debugMessage("Because stack is empty!", 35);
+            throw new SAXException(UPDATEACCESSERROR);
+        }
+        // go throw two stacks and compare every element
+        while (!stack1.isEmpty()) {
+            // Pop an element from stack1
+            NodeRecord record1 = (NodeRecord) stack1.pop();
+            // Pop an element from stack2(stack 2 maybe empty)
+            NodeRecord record2 = null;
+            try {
+                record2 = (NodeRecord) stack2.pop();
+            } catch (EmptyStackException ee) {
+                MetaCatUtil.debugMessage(
+                        "Node stack2 is empty but stack1 isn't!", 35);
+                throw new SAXException(UPDATEACCESSERROR);
             }
-            else
-            {
-              // this is a reference and go trough the vector which contains all
-              // access object
-              String referenceId = accessControlObj.getReferences();
-            
-              boolean findAccessObject = false;
-              MetaCatUtil.debugMessage("referered id for additional access "+
-                                     "mapping(go through): "+ referenceId, 35);
-              for (int i=0; i<accessObjectList.size(); i++)
-              {
-                AccessSection accessObj = 
-                                (AccessSection)accessObjectList.elementAt(i);
-                String accessObjId = accessObj.getSubTreeId();
-                MetaCatUtil.debugMessage("access obj id in the list(go through): "
-                                        + accessObjId, 35);
-                if (referenceId != null && accessObj != null &&
-                    referenceId.equals(accessObjId))
-                {
-                  writeGivenAccessRuleIntoDB(accessObj, topLevel, subSectionId);
-                  findAccessObject = true;
-                }//if
-              }//for
-              // if we couldn't find an access subtree id for this reference id
-              if (!findAccessObject)
-              {
-                throw new SAXException("The referenceid: " + referenceId +
-                               " is not access subtree");
-              }//if
-            }//else
-          }//else
-       }//try
-       catch (Exception e)
-       {
-         
-         MetaCatUtil.debugMessage("error in EmlSAXHandler.writeAddtionalAccess"
-                                   + ": "+e.getMessage(), 30);
-         throw new SAXException(e.getMessage());
-       }
-     }//while
-    }//for
-  }//writeAccessRuletoDB
-  
-  /* Write a gaven access rule into db*/
-  private void writeGivenAccessRuleIntoDB(AccessSection accessSection, 
-                                         boolean topLevel, String subSectionId) 
-                                         throws SAXException
-  {
-     if (accessSection == null)
-     {
-       throw new SAXException("The access object is null");
-     }
-     
-      String permOrder = accessSection.getPermissionOrder();
-      String sql = null;
-      PreparedStatement pstmt = null;
-      if (topLevel)
-      {
-        sql = "INSERT INTO xml_access (docid, principal_name, permission, "+
-                 "perm_type, perm_order, accessfileid) VALUES " +
-                 " (?, ?, ?, ?, ?, ?)";
-      }
-      else
-      {
-        sql ="INSERT INTO xml_access (docid,principal_name, "+ 
-             "permission, perm_type, perm_order, accessfileid, subtreeid, "+
-             " startnodeid, endnodeid) VALUES" +
-             " (?, ?, ?, ?, ?, ?, ?, ?, ?)";
-      }
-      try 
-      {
-     
-        pstmt = connection.prepareStatement(sql);
-        // Increase DBConnection usage count
-        connection.increaseUsageCount(1);
-        // Bind the values to the query
-        pstmt.setString(1, docid);
-        MetaCatUtil.debugMessage("Docid in accesstable: "+ docid, 35);
-        pstmt.setString(6, docid);
-        MetaCatUtil.debugMessage("Accessfileid in accesstable: "+ docid, 35);
-        pstmt.setString(5, permOrder);
-        MetaCatUtil.debugMessage("PermOder in accesstable: "+ permOrder, 35);
-        // if it is not top level, set subsection id
-        if (!topLevel)
-        {
-          long startNodeId = 0;
-          long endNodeId = 0;
-          // for subtree should specify the
-          if (subSectionId == null)
-          {
-            throw new SAXException("The subsection is null");
-          }
-          // go through the substree list vector and found the start node id
-          // and stop node id for this subtree id
-          for (int i=0; i<subTreeList.size(); i++)
-          {
-            SubTree tree = (SubTree)subTreeList.elementAt(i);
-            String subTreeId = tree.getSubTreeId();
-            if (subSectionId.equals(subTreeId))
-            {
-              startNodeId = tree.getStartNodeId();
-              endNodeId = tree.getEndNodeId(); 
+            // if two records are not same throw a exception
+            if (!record1.contentEquals(record2)) {
+                MetaCatUtil
+                        .debugMessage(
+                                "Two records from new and old stack are not "
+                                        + "same!", 30);
+                throw new SAXException(UPDATEACCESSERROR);
             }//if
-          }//for
-          if (startNodeId == 0 || endNodeId == 0)
-          {
-            throw new SAXException("Could find the subtree"
-                                   + "for this id: "+subSectionId);
-          }
-          pstmt.setString(7, subSectionId);
-          MetaCatUtil.debugMessage("SubSectionId in accesstable: "+ 
-                                    subSectionId, 35);
-          pstmt.setLong(8, startNodeId);
-          MetaCatUtil.debugMessage("Start node id is: " + startNodeId, 35);
-          pstmt.setLong(9, endNodeId);
-          MetaCatUtil.debugMessage("End node id is: " + endNodeId, 35);
-          
-        }
-      
-        Vector accessRules = accessSection.getAccessRules();
-        // go through every rule
-        for (int i=0; i<accessRules.size(); i++)
-        {
-          AccessRule rule = (AccessRule)accessRules.elementAt(i);
-          String permType = rule.getPermissionType();
-          int permission = rule.getPermission();
-          pstmt.setInt(3, permission);
-          MetaCatUtil.debugMessage("permission in accesstable: "+ permission, 35);
-          pstmt.setString(4, permType);
-          MetaCatUtil.debugMessage("Permtype in accesstable: "+ permType, 35);
-          // go through every principle in rule
-          Vector nameVector = rule.getPrincipal();
-          for ( int j = 0; j < nameVector.size(); j++ ) 
-          {
-            String prName = (String)nameVector.elementAt(j);
-            pstmt.setString(2, prName);
-            MetaCatUtil.debugMessage("Principal in accesstable: "+prName, 35);
-            pstmt.execute();
-          }//for
+        }//while
+
+        // now stack1 is empty and we should make sure stack2 is empty too
+        if (!stack2.isEmpty()) {
+            MetaCatUtil.debugMessage(
+                    "stack2 still have some elements while stack "
+                            + "is empty! ", 30);
+            throw new SAXException(UPDATEACCESSERROR);
+        }//if
+    }//comparingNodeStacks
+
+    /* The method to write addtional access rule into db. */
+    private void writeAddtionalAccessRuleToDB() throws SAXException
+    {
+
+        PreparedStatement pstmt = null;
+        boolean topLevel = false;
+        // go through the vector which contains the additional access control
+        //hashtable. Each hashtable has info for one additonalmetadata
+        // container
+        for (int j = 0; j < additionalAccessMapList.size(); j++) {
+
+            Hashtable accessControlMap = (Hashtable) additionalAccessMapList
+                    .elementAt(j);
+            // additional access rule
+            Enumeration en = accessControlMap.keys();
+
+            while (en.hasMoreElements()) {
+                try {
+                    // Get subsection id
+                    String subSectionId = (String) en.nextElement();
+                    MetaCatUtil.debugMessage(
+                            "sub section id in additional access mapping"
+                                    + "(go through): " + subSectionId, 35);
+
+                    if (subSectionId == null) { 
+                    // if id is null, terminate the program
+                    throw new SAXException("subtree id is null"); }
+                    // Get AccessSection Object
+                    Object accessSectionObj = accessControlMap
+                            .get(subSectionId);
+                    if (accessSectionObj == null) {
+                        // if accesssection is null, terminate the program
+                        throw new SAXException("access subtree is null");
+                    } else {
+                        AccessSection accessControlObj = (AccessSection) accessSectionObj;
+                        // if the access section is not references, write it to
+                        // db
+                        if (accessControlObj.getReferences() == null) {
+                            writeGivenAccessRuleIntoDB(accessControlObj,
+                                    topLevel, subSectionId);
+                        } else {
+                            // this is a reference and go trough the vector
+                            // which contains all
+                            // access object
+                            String referenceId = accessControlObj
+                                    .getReferences();
+
+                            boolean findAccessObject = false;
+                            MetaCatUtil.debugMessage(
+                                    "referered id for additional access "
+                                            + "mapping(go through): "
+                                            + referenceId, 35);
+                            for (int i = 0; i < accessObjectList.size(); i++) {
+                                AccessSection accessObj = (AccessSection) accessObjectList
+                                        .elementAt(i);
+                                String accessObjId = accessObj.getSubTreeId();
+                                MetaCatUtil.debugMessage(
+                                        "access obj id in the list(go through): "
+                                                + accessObjId, 35);
+                                if (referenceId != null && accessObj != null
+                                        && referenceId.equals(accessObjId)) {
+                                    writeGivenAccessRuleIntoDB(accessObj,
+                                            topLevel, subSectionId);
+                                    findAccessObject = true;
+                                }//if
+                            }//for
+                            // if we couldn't find an access subtree id for
+                            // this reference id
+                            if (!findAccessObject) { throw new SAXException(
+                                    "The referenceid: " + referenceId
+                                            + " is not access subtree"); }//if
+                        }//else
+                    }//else
+                }//try
+                catch (Exception e) {
+
+                    MetaCatUtil.debugMessage(
+                            "error in EmlSAXHandler.writeAddtionalAccess"
+                                    + ": " + e.getMessage(), 30);
+                    throw new SAXException(e.getMessage());
+                }
+            }//while
         }//for
-        pstmt.close();
-      }//try 
-      catch (SQLException e) 
-      {
-        throw new 
-        SAXException("EMLSAXHandler.writeAccessRuletoDB(): " + e.getMessage());
-      }//catch
-      finally
-      {
-        try
-        {
-          pstmt.close();
+    }//writeAccessRuletoDB
+
+    /* Write a gaven access rule into db */
+    private void writeGivenAccessRuleIntoDB(AccessSection accessSection,
+            boolean topLevel, String subSectionId) throws SAXException
+    {
+        if (accessSection == null) { throw new SAXException(
+                "The access object is null"); }
+
+        String permOrder = accessSection.getPermissionOrder();
+        String sql = null;
+        PreparedStatement pstmt = null;
+        if (topLevel) {
+            sql = "INSERT INTO xml_access (docid, principal_name, permission, "
+                    + "perm_type, perm_order, accessfileid) VALUES "
+                    + " (?, ?, ?, ?, ?, ?)";
+        } else {
+            sql = "INSERT INTO xml_access (docid,principal_name, "
+                    + "permission, perm_type, perm_order, accessfileid, subtreeid, "
+                    + " startnodeid, endnodeid) VALUES"
+                    + " (?, ?, ?, ?, ?, ?, ?, ?, ?)";
         }
-        catch(SQLException ee)
-        {
-          throw new 
-          SAXException("EMLSAXHandler.writeAccessRuletoDB(): " + 
-          ee.getMessage());
-        }
-      }//finally
-     
-  }//writeGivenAccessRuleIntoDB
-  
-  
-  
-    /* Write a gaven access rule into db*/
-  private void writeAccessRuleForRalatedDataFileIntoDB
-                  (AccessSection accessSection, String dataId) 
-                                         throws SAXException
-  {
-      if (accessSection == null)
-      {
-        throw new SAXException("The access object is null");
-      }
-      // get rid of rev from dataId
-      dataId = MetaCatUtil.getDocIdFromString(dataId);
-      String permOrder = accessSection.getPermissionOrder();
-      String sql = null;
-      PreparedStatement pstmt = null;
-      sql = "INSERT INTO xml_access (docid, principal_name, permission, "+
-                 "perm_type, perm_order, accessfileid) VALUES " +
-                 " (?, ?, ?, ?, ?, ?)";
-   
-      try 
-      {
-     
-        pstmt = connection.prepareStatement(sql);
-        // Increase DBConnection usage count
-        connection.increaseUsageCount(1);
-        // Bind the values to the query
-        pstmt.setString(1, dataId);
-        MetaCatUtil.debugMessage("Docid in accesstable: "+ docid, 35);
-        pstmt.setString(6, docid);
-        MetaCatUtil.debugMessage("Accessfileid in accesstable: "+ docid, 35);
-        pstmt.setString(5, permOrder);
-        MetaCatUtil.debugMessage("PermOder in accesstable: "+ permOrder, 35);
-        // if it is not top level, set subsection id
-            
-        Vector accessRules = accessSection.getAccessRules();
-        // go through every rule
-        for (int i=0; i<accessRules.size(); i++)
-        {
-          AccessRule rule = (AccessRule)accessRules.elementAt(i);
-          String permType = rule.getPermissionType();
-          int permission = rule.getPermission();
-          pstmt.setInt(3, permission);
-          MetaCatUtil.debugMessage("permission in accesstable: "+ permission, 35);
-          pstmt.setString(4, permType);
-          MetaCatUtil.debugMessage("Permtype in accesstable: "+ permType, 35);
-          // go through every principle in rule
-          Vector nameVector = rule.getPrincipal();
-          for ( int j = 0; j < nameVector.size(); j++ ) 
-          {
-            String prName = (String)nameVector.elementAt(j);
-            pstmt.setString(2, prName);
-            MetaCatUtil.debugMessage("Principal in accesstable: "+prName, 35);
-            pstmt.execute();
-          }//for
-        }//for
-        pstmt.close();
-      }//try 
-      catch (SQLException e) 
-      {
-        throw new 
-        SAXException("EMLSAXHandler.writeAccessRuletoDB(): " + e.getMessage());
-      }//catch
-      finally
-      {
-        try
-        {
-          pstmt.close();
-        }
-        catch(SQLException ee)
-        {
-          throw new 
-          SAXException("EMLSAXHandler.writeAccessRuletoDB(): " + 
-          ee.getMessage());
-        }
-      }//finally
-     
-  }//writeAccessRuleForRalatedDataFileIntoDB
-  
-  
-  
-  
-  
-  /* Delete from db all permission for resources related to @aclid if any.*/
-  private void deletePermissionsInAccessTable(String aclid) 
-          throws SAXException 
-  {
-    Statement stmt = null;
-    try
+        try {
+
+            pstmt = connection.prepareStatement(sql);
+            // Increase DBConnection usage count
+            connection.increaseUsageCount(1);
+            // Bind the values to the query
+            pstmt.setString(1, docid);
+            MetaCatUtil.debugMessage("Docid in accesstable: " + docid, 35);
+            pstmt.setString(6, docid);
+            MetaCatUtil.debugMessage("Accessfileid in accesstable: " + docid,
+                    35);
+            pstmt.setString(5, permOrder);
+            MetaCatUtil.debugMessage("PermOder in accesstable: " + permOrder,
+                    35);
+            // if it is not top level, set subsection id
+            if (!topLevel) {
+                long startNodeId = 0;
+                long endNodeId = 0;
+                // for subtree should specify the
+                if (subSectionId == null) { throw new SAXException(
+                        "The subsection is null"); }
+                // go through the substree list vector and found the start node
+                // id
+                // and stop node id for this subtree id
+                for (int i = 0; i < subTreeList.size(); i++) {
+                    SubTree tree = (SubTree) subTreeList.elementAt(i);
+                    String subTreeId = tree.getSubTreeId();
+                    if (subSectionId.equals(subTreeId)) {
+                        startNodeId = tree.getStartNodeId();
+                        endNodeId = tree.getEndNodeId();
+                    }//if
+                }//for
+                if (startNodeId == 0 || endNodeId == 0) { throw new SAXException(
+                        "Could find the subtree" + "for this id: "
+                                + subSectionId); }
+                pstmt.setString(7, subSectionId);
+                MetaCatUtil.debugMessage("SubSectionId in accesstable: "
+                        + subSectionId, 35);
+                pstmt.setLong(8, startNodeId);
+                MetaCatUtil
+                        .debugMessage("Start node id is: " + startNodeId, 35);
+                pstmt.setLong(9, endNodeId);
+                MetaCatUtil.debugMessage("End node id is: " + endNodeId, 35);
+
+            }
+
+            Vector accessRules = accessSection.getAccessRules();
+            // go through every rule
+            for (int i = 0; i < accessRules.size(); i++) {
+                AccessRule rule = (AccessRule) accessRules.elementAt(i);
+                String permType = rule.getPermissionType();
+                int permission = rule.getPermission();
+                pstmt.setInt(3, permission);
+                MetaCatUtil.debugMessage("permission in accesstable: "
+                        + permission, 35);
+                pstmt.setString(4, permType);
+                MetaCatUtil.debugMessage(
+                        "Permtype in accesstable: " + permType, 35);
+                // go through every principle in rule
+                Vector nameVector = rule.getPrincipal();
+                for (int j = 0; j < nameVector.size(); j++) {
+                    String prName = (String) nameVector.elementAt(j);
+                    pstmt.setString(2, prName);
+                    MetaCatUtil.debugMessage("Principal in accesstable: "
+                            + prName, 35);
+                    pstmt.execute();
+                }//for
+            }//for
+            pstmt.close();
+        }//try
+        catch (SQLException e) {
+            throw new SAXException("EMLSAXHandler.writeAccessRuletoDB(): "
+                    + e.getMessage());
+        }//catch
+        finally {
+            try {
+                pstmt.close();
+            } catch (SQLException ee) {
+                throw new SAXException("EMLSAXHandler.writeAccessRuletoDB(): "
+                        + ee.getMessage());
+            }
+        }//finally
+
+    }//writeGivenAccessRuleIntoDB
+
+    /* Write a gaven access rule into db */
+    private void writeAccessRuleForRalatedDataFileIntoDB(
+            AccessSection accessSection, String dataId) throws SAXException
     {
-      // delete all acl records for resources related to @aclid if any
-      stmt = connection.createStatement();
-      // Increase DBConnection usage count
-      connection.increaseUsageCount(1);
-      stmt.execute("DELETE FROM xml_access WHERE accessfileid = '" + aclid +
-                   "'"); 
-    
-    }
-    catch (SQLException e)
+        if (accessSection == null) { throw new SAXException(
+                "The access object is null"); }
+        // get rid of rev from dataId
+        dataId = MetaCatUtil.getDocIdFromString(dataId);
+        String permOrder = accessSection.getPermissionOrder();
+        String sql = null;
+        PreparedStatement pstmt = null;
+        sql = "INSERT INTO xml_access (docid, principal_name, permission, "
+                + "perm_type, perm_order, accessfileid) VALUES "
+                + " (?, ?, ?, ?, ?, ?)";
+
+        try {
+
+            pstmt = connection.prepareStatement(sql);
+            // Increase DBConnection usage count
+            connection.increaseUsageCount(1);
+            // Bind the values to the query
+            pstmt.setString(1, dataId);
+            MetaCatUtil.debugMessage("Docid in accesstable: " + docid, 35);
+            pstmt.setString(6, docid);
+            MetaCatUtil.debugMessage("Accessfileid in accesstable: " + docid,
+                    35);
+            pstmt.setString(5, permOrder);
+            MetaCatUtil.debugMessage("PermOder in accesstable: " + permOrder,
+                    35);
+            // if it is not top level, set subsection id
+
+            Vector accessRules = accessSection.getAccessRules();
+            // go through every rule
+            for (int i = 0; i < accessRules.size(); i++) {
+                AccessRule rule = (AccessRule) accessRules.elementAt(i);
+                String permType = rule.getPermissionType();
+                int permission = rule.getPermission();
+                pstmt.setInt(3, permission);
+                MetaCatUtil.debugMessage("permission in accesstable: "
+                        + permission, 35);
+                pstmt.setString(4, permType);
+                MetaCatUtil.debugMessage(
+                        "Permtype in accesstable: " + permType, 35);
+                // go through every principle in rule
+                Vector nameVector = rule.getPrincipal();
+                for (int j = 0; j < nameVector.size(); j++) {
+                    String prName = (String) nameVector.elementAt(j);
+                    pstmt.setString(2, prName);
+                    MetaCatUtil.debugMessage("Principal in accesstable: "
+                            + prName, 35);
+                    pstmt.execute();
+                }//for
+            }//for
+            pstmt.close();
+        }//try
+        catch (SQLException e) {
+            throw new SAXException("EMLSAXHandler.writeAccessRuletoDB(): "
+                    + e.getMessage());
+        }//catch
+        finally {
+            try {
+                pstmt.close();
+            } catch (SQLException ee) {
+                throw new SAXException("EMLSAXHandler.writeAccessRuletoDB(): "
+                        + ee.getMessage());
+            }
+        }//finally
+
+    }//writeAccessRuleForRalatedDataFileIntoDB
+
+    /* Delete from db all permission for resources related to @aclid if any. */
+    private void deletePermissionsInAccessTable(String aclid)
+            throws SAXException
     {
-      throw new SAXException(e.getMessage());
-    }
-    finally
-    {
-      try
-      {
-        stmt.close();
-      }
-      catch (SQLException ee)
-      {
-        throw new SAXException(ee.getMessage());
-      }
-    }
-  }//deletePermissionsInAccessTable
-  
-  
-  /* In order to make sure only usr has "all" permission can update access
-   * subtree in eml document we need to keep access subtree info in 
-   * xml_accesssubtree table, such as docid, version, startnodeid, endnodeid
-   */
-  private void writeAccessSubTreeIntoDB(AccessSection accessSection, 
-                                         String level) 
-                                         throws SAXException
-  {
-     if (accessSection == null)
-     {
-       throw new SAXException("The access object is null");
-     }
-     
-      String sql = null;
-      PreparedStatement pstmt = null;
-      sql = "INSERT INTO xml_accesssubtree (docid, rev, controllevel, "+
-                 "subtreeid, startnodeid, endnodeid) VALUES " +
-                 " (?, ?, ?, ?, ?, ?)";
-      try 
-      {
-     
-        pstmt = connection.prepareStatement(sql);
-        // Increase DBConnection usage count
-        connection.increaseUsageCount(1);
-        long startNodeId = accessSection.getStartNodeId();
-        long endNodeId = accessSection.getEndNodeId();
-        String sectionId = accessSection.getSubTreeId();
-        // Bind the values to the query
-        pstmt.setString(1, docid);
-        MetaCatUtil.debugMessage("Docid in access-subtreetable: "+ docid, 35);
-        pstmt.setString(2, revision );
-        MetaCatUtil.debugMessage("rev in accesssubtreetable: "+ revision, 35);
-        pstmt.setString(3, level);
-        MetaCatUtil.debugMessage("contorl level in access-subtree table: "+
-                                  level, 35);
-        pstmt.setString(4, sectionId);
-        MetaCatUtil.debugMessage("Subtree id in access-subtree table: "+ 
-                                  sectionId, 35);
-        pstmt.setLong(5, startNodeId);
-        MetaCatUtil.debugMessage("Start node id is: " + startNodeId, 35);
-        pstmt.setLong(6, endNodeId);
-        MetaCatUtil.debugMessage("End node id is: " + endNodeId, 35);
-        pstmt.execute();
-        pstmt.close();
-      }//try 
-      catch (SQLException e) 
-      {
-        throw new 
-        SAXException("EMLSAXHandler.writeAccessSubTreeIntoDB(): " + 
-                      e.getMessage());
-      }//catch
-      finally
-      {
-        try
-        {
-          pstmt.close();
+        Statement stmt = null;
+        try {
+            // delete all acl records for resources related to @aclid if any
+            stmt = connection.createStatement();
+            // Increase DBConnection usage count
+            connection.increaseUsageCount(1);
+            stmt.execute("DELETE FROM xml_access WHERE accessfileid = '"
+                    + aclid + "'");
+
+        } catch (SQLException e) {
+            throw new SAXException(e.getMessage());
+        } finally {
+            try {
+                stmt.close();
+            } catch (SQLException ee) {
+                throw new SAXException(ee.getMessage());
+            }
         }
-        catch(SQLException ee)
-        {
-          throw new 
-          SAXException("EMLSAXHandler.writeAccessSubTreeIntoDB(): " + 
-          ee.getMessage());
-        }
-      }//finally
-     
-  }//writeAccessSubtreeIntoDB
-  
-   /* Delete every access subtree record from xml_accesssubtree.*/
-  private void deleteAccessSubTreeRecord(String docId) throws SAXException 
-  {
-    Statement stmt = null;
-    try
+    }//deletePermissionsInAccessTable
+
+    /*
+     * In order to make sure only usr has "all" permission can update access
+     * subtree in eml document we need to keep access subtree info in
+     * xml_accesssubtree table, such as docid, version, startnodeid, endnodeid
+     */
+    private void writeAccessSubTreeIntoDB(AccessSection accessSection,
+            String level) throws SAXException
     {
-      // delete all acl records for resources related to @aclid if any
-      stmt = connection.createStatement();
-      // Increase DBConnection usage count
-      connection.increaseUsageCount(1);
-      stmt.execute("DELETE FROM xml_accesssubtree WHERE docid = '" + docId + "'"); 
-   
-    }
-    catch (SQLException e)
+        if (accessSection == null) { throw new SAXException(
+                "The access object is null"); }
+
+        String sql = null;
+        PreparedStatement pstmt = null;
+        sql = "INSERT INTO xml_accesssubtree (docid, rev, controllevel, "
+                + "subtreeid, startnodeid, endnodeid) VALUES "
+                + " (?, ?, ?, ?, ?, ?)";
+        try {
+
+            pstmt = connection.prepareStatement(sql);
+            // Increase DBConnection usage count
+            connection.increaseUsageCount(1);
+            long startNodeId = accessSection.getStartNodeId();
+            long endNodeId = accessSection.getEndNodeId();
+            String sectionId = accessSection.getSubTreeId();
+            // Bind the values to the query
+            pstmt.setString(1, docid);
+            MetaCatUtil.debugMessage("Docid in access-subtreetable: " + docid,
+                    35);
+            pstmt.setString(2, revision);
+            MetaCatUtil.debugMessage("rev in accesssubtreetable: " + revision,
+                    35);
+            pstmt.setString(3, level);
+            MetaCatUtil.debugMessage("contorl level in access-subtree table: "
+                    + level, 35);
+            pstmt.setString(4, sectionId);
+            MetaCatUtil.debugMessage("Subtree id in access-subtree table: "
+                    + sectionId, 35);
+            pstmt.setLong(5, startNodeId);
+            MetaCatUtil.debugMessage("Start node id is: " + startNodeId, 35);
+            pstmt.setLong(6, endNodeId);
+            MetaCatUtil.debugMessage("End node id is: " + endNodeId, 35);
+            pstmt.execute();
+            pstmt.close();
+        }//try
+        catch (SQLException e) {
+            throw new SAXException("EMLSAXHandler.writeAccessSubTreeIntoDB(): "
+                    + e.getMessage());
+        }//catch
+        finally {
+            try {
+                pstmt.close();
+            } catch (SQLException ee) {
+                throw new SAXException(
+                        "EMLSAXHandler.writeAccessSubTreeIntoDB(): "
+                                + ee.getMessage());
+            }
+        }//finally
+
+    }//writeAccessSubtreeIntoDB
+
+    /* Delete every access subtree record from xml_accesssubtree. */
+    private void deleteAccessSubTreeRecord(String docId) throws SAXException
     {
-      throw new SAXException(e.getMessage());
-    }
-    finally
+        Statement stmt = null;
+        try {
+            // delete all acl records for resources related to @aclid if any
+            stmt = connection.createStatement();
+            // Increase DBConnection usage count
+            connection.increaseUsageCount(1);
+            stmt.execute("DELETE FROM xml_accesssubtree WHERE docid = '"
+                    + docId + "'");
+
+        } catch (SQLException e) {
+            throw new SAXException(e.getMessage());
+        } finally {
+            try {
+                stmt.close();
+            } catch (SQLException ee) {
+                throw new SAXException(ee.getMessage());
+            }
+        }
+    }//deleteAccessSubTreeRecord
+
+    // open a file writer for writing inline data to file
+    private FileWriter createInlineDataFileWriter(String fileName)
+            throws SAXException
     {
-      try
-      {
-        stmt.close();
-      }
-      catch (SQLException ee)
-      {
-        throw new SAXException(ee.getMessage());
-      }
+        FileWriter writer = null;
+        String path = MetaCatUtil.getOption("inlinedatafilepath");
+        /*
+         * File inlineDataDirectory = new File(path);
+         */
+        String newFile = path + "/" + fileName;
+        MetaCatUtil.debugMessage("inline file name: " + newFile, 30);
+        try {
+            // true means append
+            writer = new FileWriter(newFile, true);
+        } catch (IOException ioe) {
+            throw new SAXException(ioe.getMessage());
+        }
+        return writer;
     }
-  }//deleteAccessSubTreeRecord
-  
-  // open a file writer for writing inline data to file
-  private FileWriter createInlineDataFileWriter(String fileName) 
-                                               throws SAXException
-  {
-    FileWriter writer = null;
-    String path = MetaCatUtil.getOption("inlinedatafilepath");
-    /*File inlineDataDirectory = new File(path);
-    File newFile = new File(inlineDataDirectory, fileName);*/
-    String newFile = path + "/" + fileName;
-    MetaCatUtil.debugMessage("inline file name: "+newFile, 30);
-    try
+
+    // write inline data into file system and return file name(without path)
+    private void writeInlineDataIntoFile(FileWriter writer, StringBuffer data)
+            throws SAXException
     {
-      // true means append
-      writer = new FileWriter(newFile, true);
+        try {
+            writer.write(data.toString());
+            writer.flush();
+        } catch (Exception e) {
+            throw new SAXException(e.getMessage());
+        }
     }
-    catch (IOException ioe)
+
+    /*
+     * In eml2, the inline data wouldn't store in db, it store in file system
+     * The db stores file name(without path). We got the old file name from db
+     * and compare to the new in line data file
+     */
+    public boolean compareInlineDataFiles(String oldFileName, String newFileName)
+            throws McdbException
     {
-      throw new SAXException(ioe.getMessage());
+        // this method need to be testing
+        boolean same = true;
+        String data = null;
+        String path = MetaCatUtil.getOption("inlinedatafilepath");
+        // the new file name will look like path/docid.rev.2
+        File inlineDataDirectory = new File(path);
+        File oldDataFile = new File(inlineDataDirectory, oldFileName);
+        File newDataFile = new File(inlineDataDirectory, newFileName);
+        try {
+            FileReader oldFileReader = new FileReader(oldDataFile);
+            BufferedReader oldStringReader = new BufferedReader(oldFileReader);
+            FileReader newFileReader = new FileReader(newDataFile);
+            BufferedReader newStringReader = new BufferedReader(newFileReader);
+            // read first line of data
+            String oldString = oldStringReader.readLine();
+            String newString = newStringReader.readLine();
+
+            // at the end oldstring will be null
+            while (oldString != null) {
+                oldString = oldStringReader.readLine();
+                newString = newStringReader.readLine();
+                if (!oldString.equals(newString)) {
+                    same = false;
+                    break;
+                }
+            }
+
+            // if oldString is null but newString is not null, they are same
+            if (same) {
+                if (newString != null) {
+                    same = false;
+                }
+            }
+
+        } catch (Exception e) {
+            throw new McdbException(e.getMessage());
+        }
+        MetaCatUtil.debugMessage("the inline data retrieve from file: " + data,
+                50);
+        return same;
     }
-    return writer;
-  }
-  // write inline data into file system and return file name(without path)
-  private void writeInlineDataIntoFile(FileWriter writer, 
-                                               StringBuffer data) 
-                                               throws SAXException
-  {
-    try
+
+    // if xml file failed to upload, we need to call this method to delete
+    // the inline data already in file system
+    public void deleteInlineFiles()
     {
-      writer.write(data.toString());
-      writer.flush();
+        if (!inlineFileIDList.isEmpty()) {
+            for (int i = 0; i < inlineFileIDList.size(); i++) {
+                String fileName = (String) inlineFileIDList.elementAt(i);
+                deleteInlineDataFile(fileName);
+            }
+        }
     }
-    catch (Exception e)
+
+    /* delete the inline data file */
+    private void deleteInlineDataFile(String fileName)
     {
-      throw new SAXException(e.getMessage());
+
+        String path = MetaCatUtil.getOption("inlinedatafilepath");
+        File inlineDataDirectory = new File(path);
+        File newFile = new File(inlineDataDirectory, fileName);
+        newFile.delete();
+
     }
-  }
-  
-  /* In eml2, the inline data wouldn't store in db, it store in file system
-   * The db stores file name(without path). We got the old file name from db
-   * and compare to the new in line data file
-   */
-  public boolean compareInlineDataFiles(String oldFileName, String newFileName)
-                                                throws McdbException
-  {
-    // this method need to be testing
-    boolean same = true;
-    String data = null;
-    String path = MetaCatUtil.getOption("inlinedatafilepath");
-    // the new file name will look like path/docid.rev.2
-    File inlineDataDirectory = new File(path);
-    File oldDataFile = new File(inlineDataDirectory, oldFileName);
-    File newDataFile = new File(inlineDataDirectory, newFileName);
-    try
+
+    /*
+     * In eml2, the inline data wouldn't store in db, it store in file system
+     * The db stores file name(without path).
+     */
+    public static Reader readInlineDataFromFileSystem(String fileName)
+            throws McdbException
     {
-      FileReader oldFileReader = new FileReader(oldDataFile);
-      BufferedReader oldStringReader = new BufferedReader(oldFileReader);
-      FileReader newFileReader = new FileReader(newDataFile);
-      BufferedReader newStringReader = new BufferedReader(newFileReader);
-      // read first line of data
-      String oldString = oldStringReader.readLine();
-      String newString = newStringReader.readLine();
-     
-      // at the end oldstring will be null
-      while (oldString != null)
-      {
-        oldString = oldStringReader.readLine();
-        newString = newStringReader.readLine();
-        if (!oldString.equals(newString))
-        {
-          same = false;
-          break;
+        //BufferedReader stringReader = null;
+        FileReader fileReader = null;
+        String path = MetaCatUtil.getOption("inlinedatafilepath");
+        // the new file name will look like path/docid.rev.2
+        File inlineDataDirectory = new File(path);
+        File dataFile = new File(inlineDataDirectory, fileName);
+        try {
+            fileReader = new FileReader(dataFile);
+            //stringReader = new BufferedReader(fileReader);
+        } catch (Exception e) {
+            throw new McdbException(e.getMessage());
         }
-      }
-      
-      // if oldString is null but newString is not null, they are same
-      if (same)
-      {
-         if (newString != null)
-         {
-           same = false;
-         }
-      }
-      
+        // return stringReader;
+        return fileReader;
     }
-    catch (Exception e)
+
+    /* Delete relations */
+    private void deleteRelations() throws SAXException
     {
-      throw new McdbException(e.getMessage());
+        PreparedStatement pStmt = null;
+        String sql = "DELETE FROM xml_relation where docid =?";
+        try {
+            pStmt = connection.prepareStatement(sql);
+            //bind variable
+            pStmt.setString(1, docid);
+            //execute query
+            pStmt.execute();
+            pStmt.close();
+        }//try
+        catch (SQLException e) {
+            throw new SAXException("EMLSAXHandler.deleteRelations(): "
+                    + e.getMessage());
+        }//catch
+        finally {
+            try {
+                pStmt.close();
+            }//try
+            catch (SQLException ee) {
+                throw new SAXException("EMLSAXHandler.deleteRelations: "
+                        + ee.getMessage());
+            }//catch
+        }//finally
     }
-    MetaCatUtil.debugMessage("the inline data retrieve from file: "+data, 50);
-    return same;
-  }
-  
-  // if xml file failed to upload, we need to call this method to delete
-  // the inline data already in file system
-  public void deleteInlineFiles()
-  {
-     if (!inlineFileIDList.isEmpty())
-     {
-       for ( int i=0; i<inlineFileIDList.size(); i++)
-       {
-         String fileName = (String) inlineFileIDList.elementAt(i);
-         deleteInlineDataFile(fileName);
-       }
-     }
-  }
-  
-  /* delete the inline data file */
-  private void deleteInlineDataFile(String fileName)
-  {
-    
-     String path = MetaCatUtil.getOption("inlinedatafilepath");
-     File inlineDataDirectory = new File(path);
-     File newFile = new File(inlineDataDirectory, fileName);
-     newFile.delete();
-  
-  }
-  
-   /* In eml2, the inline data wouldn't store in db, it store in file system
-   * The db stores file name(without path).
-   */
-  public static Reader readInlineDataFromFileSystem(String fileName) 
-                                              throws McdbException
-  {
-    //BufferedReader stringReader = null;
-    FileReader fileReader = null;
-    String path = MetaCatUtil.getOption("inlinedatafilepath");
-    // the new file name will look like path/docid.rev.2
-    File inlineDataDirectory = new File(path);
-    File dataFile = new File(inlineDataDirectory, fileName);
-    try
+
+    /* Write an online data file id into xml_relation table */
+    private void writeOnlineDataFileIdIntoRelationTable(String dataId)
+            throws SAXException
     {
-      fileReader = new FileReader(dataFile);
-      //stringReader = new BufferedReader(fileReader);
-    }
-    catch (Exception e)
-    {
-      throw new McdbException(e.getMessage());
-    }
-   // return stringReader;
-   return fileReader;
-  }
-  
-  /* Delete relations */
-  private void deleteRelations() throws SAXException
-  {
-    PreparedStatement pStmt = null;
-    String sql = "DELETE FROM xml_relation where docid =?";
-    try
-    {
-      pStmt = connection.prepareStatement(sql);
-      //bind variable
-      pStmt.setString(1, docid);
-      //execute query
-      pStmt.execute();
-      pStmt.close();
-    }//try
-    catch (SQLException e) 
-    {
-       throw new 
-       SAXException("EMLSAXHandler.deleteRelations(): " + 
-                      e.getMessage());
-    }//catch
-    finally
-    {
-      try
-      {
-        pStmt.close();
-      }//try
-      catch(SQLException ee)
-      {
-        throw new 
-        SAXException("EMLSAXHandler.deleteRelations: " + 
-        ee.getMessage());
-      }//catch
-    }//finally
-  }
-  
-  /* Write an online data file id into xml_relation table*/
-  private void writeOnlineDataFileIdIntoRelationTable(String dataId) 
-                                                        throws SAXException
-  {
-    // Get rid of rev
-    dataId = MetaCatUtil.getDocIdFromString(dataId);
-    PreparedStatement pStmt = null;
-    String sql = "INSERT into xml_relation (docid, packagetype, subject, "+
-                 "relationship, object) values (?, ?, ?, ?, ?)";
-    try
-    {
-      pStmt = connection.prepareStatement(sql);
-      //bind variable
-      pStmt.setString(1, docid);
-      pStmt.setString(2, DocumentImpl.EMLNAMESPACE);
-      pStmt.setString(3, docid);
-      pStmt.setString(4, RELATION);
-      pStmt.setString(5, dataId);
-      //execute query
-      pStmt.execute();
-      pStmt.close();
-    }//try
-    catch (SQLException e) 
-    {
-       throw new 
-       SAXException("EMLSAXHandler.writeOnlineDataFileIdIntoRelationTable(): " + 
-                      e.getMessage());
-    }//catch
-    finally
-    {
-      try
-      {
-        pStmt.close();
-      }//try
-      catch(SQLException ee)
-      {
-        throw new 
-        SAXException("EMLSAXHandler.writeOnlineDataFileIdIntoRelationTable(): " + 
-        ee.getMessage());
-      }//catch
-    }//finally
-    
-  }//writeOnlineDataFileIdIntoRelationTable
-  
- 
+        // Get rid of rev
+        dataId = MetaCatUtil.getDocIdFromString(dataId);
+        PreparedStatement pStmt = null;
+        String sql = "INSERT into xml_relation (docid, packagetype, subject, "
+                + "relationship, object) values (?, ?, ?, ?, ?)";
+        try {
+            pStmt = connection.prepareStatement(sql);
+            //bind variable
+            pStmt.setString(1, docid);
+            pStmt.setString(2, DocumentImpl.EMLNAMESPACE);
+            pStmt.setString(3, docid);
+            pStmt.setString(4, RELATION);
+            pStmt.setString(5, dataId);
+            //execute query
+            pStmt.execute();
+            pStmt.close();
+        }//try
+        catch (SQLException e) {
+            throw new SAXException(
+                    "EMLSAXHandler.writeOnlineDataFileIdIntoRelationTable(): "
+                            + e.getMessage());
+        }//catch
+        finally {
+            try {
+                pStmt.close();
+            }//try
+            catch (SQLException ee) {
+                throw new SAXException(
+                        "EMLSAXHandler.writeOnlineDataFileIdIntoRelationTable(): "
+                                + ee.getMessage());
+            }//catch
+        }//finally
+
+    }//writeOnlineDataFileIdIntoRelationTable
+
 }
